﻿using System.Windows.Forms;

namespace MultipleJniors
{
    class JniorTreeNode : TreeNode
    {
        private JniorConnection _jniorConnection;

        private TreeNode _connectionStatusNode;
        private TreeNode _authenticationStatusNode;



        public JniorTreeNode(JniorConnection jniorConnection)
        {
            _jniorConnection = jniorConnection;
            Text = jniorConnection.WebSocket.Host + ":" + jniorConnection.WebSocket.Port;

            jniorConnection.WebSocket.Connected += WebSocket_Connected;
            jniorConnection.WebSocket.Disconnected += WebSocket_Disconnected;
            _connectionStatusNode = Nodes.Add("Connection - Waiting...");

            jniorConnection.WebSocket.Authorized += WebSocket_Authorized;
            _authenticationStatusNode = Nodes.Add("Authentication - Waiting...");
        }



        private void WebSocket_Connected(object sender, System.EventArgs e)
        {
            JniorConnection_ConnectionStatusUpdate(sender, e);
        }



        private void WebSocket_Disconnected(object sender, System.EventArgs e)
        {
            JniorConnection_ConnectionStatusUpdate(sender, e);
        }



        private void JniorConnection_ConnectionStatusUpdate(object sender, System.EventArgs e)
        {
            TreeView.Invoke((MethodInvoker)delegate ()
            {
                _connectionStatusNode.Text = "Connection - " + (_jniorConnection.WebSocket.IsOpened ? "Connected" : "NOT Connected");
            });
        }



        private void WebSocket_Authorized(object sender, System.EventArgs e)
        {
            TreeView.Invoke((MethodInvoker)delegate ()
            {
                _authenticationStatusNode.Text = "Authentication - " + (_jniorConnection.WebSocket.IsAuthenticated ? "Authenticated" : "NOT Authenticated");
            });
        }
    }
}
